# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tenant': 'str',
        'id': 'str',
        'name': 'str',
        'form': 'str',
        'styles': 'str',
        'source_type': 'str',
        'source_id': 'str',
        'type': 'str',
        'status': 'str',
        'created_date': 'datetime',
        'modified_date': 'datetime',
        'form_format': 'str',
        'provider_ref': 'str'
    }

    attribute_map = {
        'tenant': 'tenant',
        'id': 'id',
        'name': 'name',
        'form': 'form',
        'styles': 'styles',
        'source_type': 'sourceType',
        'source_id': 'sourceId',
        'type': 'type',
        'status': 'status',
        'created_date': 'createdDate',
        'modified_date': 'modifiedDate',
        'form_format': 'formFormat',
        'provider_ref': 'providerRef'
    }

    def __init__(self, tenant=None, id=None, name=None, form=None, styles=None, source_type=None, source_id=None, type=None, status=None, created_date=None, modified_date=None, form_format=None, provider_ref=None):  # noqa: E501
        """FormDefinition - a model defined in Swagger"""  # noqa: E501
        self._tenant = None
        self._id = None
        self._name = None
        self._form = None
        self._styles = None
        self._source_type = None
        self._source_id = None
        self._type = None
        self._status = None
        self._created_date = None
        self._modified_date = None
        self._form_format = None
        self._provider_ref = None
        self.discriminator = None
        if tenant is not None:
            self.tenant = tenant
        if id is not None:
            self.id = id
        self.name = name
        if form is not None:
            self.form = form
        if styles is not None:
            self.styles = styles
        if source_type is not None:
            self.source_type = source_type
        if source_id is not None:
            self.source_id = source_id
        if type is not None:
            self.type = type
        self.status = status
        if created_date is not None:
            self.created_date = created_date
        if modified_date is not None:
            self.modified_date = modified_date
        if form_format is not None:
            self.form_format = form_format
        if provider_ref is not None:
            self.provider_ref = provider_ref

    @property
    def tenant(self):
        """Gets the tenant of this FormDefinition.  # noqa: E501


        :return: The tenant of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._tenant

    @tenant.setter
    def tenant(self, tenant):
        """Sets the tenant of this FormDefinition.


        :param tenant: The tenant of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._tenant = tenant

    @property
    def id(self):
        """Gets the id of this FormDefinition.  # noqa: E501


        :return: The id of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FormDefinition.


        :param id: The id of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this FormDefinition.  # noqa: E501


        :return: The name of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FormDefinition.


        :param name: The name of this FormDefinition.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def form(self):
        """Gets the form of this FormDefinition.  # noqa: E501


        :return: The form of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._form

    @form.setter
    def form(self, form):
        """Sets the form of this FormDefinition.


        :param form: The form of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._form = form

    @property
    def styles(self):
        """Gets the styles of this FormDefinition.  # noqa: E501


        :return: The styles of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._styles

    @styles.setter
    def styles(self, styles):
        """Sets the styles of this FormDefinition.


        :param styles: The styles of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._styles = styles

    @property
    def source_type(self):
        """Gets the source_type of this FormDefinition.  # noqa: E501


        :return: The source_type of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._source_type

    @source_type.setter
    def source_type(self, source_type):
        """Sets the source_type of this FormDefinition.


        :param source_type: The source_type of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._source_type = source_type

    @property
    def source_id(self):
        """Gets the source_id of this FormDefinition.  # noqa: E501


        :return: The source_id of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._source_id

    @source_id.setter
    def source_id(self, source_id):
        """Sets the source_id of this FormDefinition.


        :param source_id: The source_id of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._source_id = source_id

    @property
    def type(self):
        """Gets the type of this FormDefinition.  # noqa: E501


        :return: The type of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this FormDefinition.


        :param type: The type of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def status(self):
        """Gets the status of this FormDefinition.  # noqa: E501


        :return: The status of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this FormDefinition.


        :param status: The status of this FormDefinition.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["OFF", "ON", "INVALID", "GENERATED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def created_date(self):
        """Gets the created_date of this FormDefinition.  # noqa: E501


        :return: The created_date of this FormDefinition.  # noqa: E501
        :rtype: datetime
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date):
        """Sets the created_date of this FormDefinition.


        :param created_date: The created_date of this FormDefinition.  # noqa: E501
        :type: datetime
        """

        self._created_date = created_date

    @property
    def modified_date(self):
        """Gets the modified_date of this FormDefinition.  # noqa: E501


        :return: The modified_date of this FormDefinition.  # noqa: E501
        :rtype: datetime
        """
        return self._modified_date

    @modified_date.setter
    def modified_date(self, modified_date):
        """Sets the modified_date of this FormDefinition.


        :param modified_date: The modified_date of this FormDefinition.  # noqa: E501
        :type: datetime
        """

        self._modified_date = modified_date

    @property
    def form_format(self):
        """Gets the form_format of this FormDefinition.  # noqa: E501


        :return: The form_format of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._form_format

    @form_format.setter
    def form_format(self, form_format):
        """Sets the form_format of this FormDefinition.


        :param form_format: The form_format of this FormDefinition.  # noqa: E501
        :type: str
        """
        allowed_values = ["YAML", "JSON"]  # noqa: E501
        if form_format not in allowed_values:
            raise ValueError(
                "Invalid value for `form_format` ({0}), must be one of {1}"  # noqa: E501
                .format(form_format, allowed_values)
            )

        self._form_format = form_format

    @property
    def provider_ref(self):
        """Gets the provider_ref of this FormDefinition.  # noqa: E501


        :return: The provider_ref of this FormDefinition.  # noqa: E501
        :rtype: str
        """
        return self._provider_ref

    @provider_ref.setter
    def provider_ref(self, provider_ref):
        """Sets the provider_ref of this FormDefinition.


        :param provider_ref: The provider_ref of this FormDefinition.  # noqa: E501
        :type: str
        """

        self._provider_ref = provider_ref

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
